PROGRAM CDIR;

{$R-}    { Range checking off }
{$B-}    { Boolean short circuiting off }
{$S+}    { Stack checking on }
{$I+}    { I/O checking on }
{$N-}    { No numeric coprocessor }
{$V-}    { Relaxed string type-checking }

USES CRT, DOS;

CONST MaxEntries = 1024; { Main program limit }
      Version = '1.01';
      Extra = '(Freeware by Al)';
      MaxColors = 41;
      DirColor = 112;
      OverflowColor = 7;
      LineColor = 15;
      CA : ARRAY[ 1..MaxColors, 1..2 ] OF BYTE = ( ( Black, LightGray ),
           ( LightGreen, Black ), ( LightCyan, Black ),
           ( LightRed, Black ), ( LightMagenta, Black ), ( Yellow, Black ),
           ( White, Black ), ( LightCyan, Blue ),( LightRed, Blue ),
           ( LightMagenta, Blue ),( Yellow, Blue ), ( White, Blue ),
           ( Black, Green ), ( Yellow, Brown ), ( White, Brown ),
           ( Yellow, Green ), ( White, Green ), ( Black, Cyan ),
           ( Blue, Cyan ),( Magenta, Cyan ), ( Yellow, Cyan ),
           ( White, Cyan ),( Black, Red ), ( LightGreen, Red ),
           ( LightCyan, Red ), ( LightMagenta, Red ), ( Yellow, Red ),
           ( White, Red ), ( Black, Magenta ), ( LightGreen, Magenta ),
           ( LightCyan, Magenta ), ( LightRed, Magenta ),
           ( Yellow, Magenta ), ( White, Magenta ),( Black, Brown ),
           ( LightGreen, Brown ), ( LightCyan, Brown ), ( LightRed, Brown ),
           ( LightMagenta, Brown ), ( LightBlue, Black ),
           ( LightGray, Black ) );

TYPE Str3 = STRING[3];
     Str8 = STRING[8];
     Str12 = STRING[12];
     Str20 = STRING[20];
     Str80 = STRING[80];
     Str255 = STRING[255];
     ECrec = RECORD
               E : Str3;
               C : BYTE;
             END; { RECORD }
  (*  SearchRec = record
      Fill: array[1..2] of byte;
      Attr : byte;
      Time : longint;
      Size : longint;
      Name : string[12];
      end;
  *)

VAR aFN : ARRAY[1..MaxEntries] OF Str8;
    aFE : ARRAY[1..MaxEntries] OF Str3;
    aFS : ARRAY[1..MaxEntries] OF LongInt;
    aFT : ARRAY[1..MaxEntries] OF LongInt;
    aFA : ARRAY[1..MaxEntries] OF ShortInt;  {Attribute byte}
                                             {ShortInt allows -1 to be used
                                              for Directory attribute (16)
                                              for sorting purposes - Dsort}
    aFD : ARRAY[1..MaxEntries] OF Byte;  { Color OR Directory # }
    aFZ : ARRAY[1..MaxEntries] OF Byte;  { Special Flag - used to put
                                           directories at front of list }
    INN : INTEGER;
    LinesCh : CHAR;
    LinesBT, ShowHid, OverflowTF : BOOLEAN;
    NumColor : BYTE;
    aEC : ARRAY[1..MaxEntries] OF ECrec;  {Ext/Color Record}
    ColorTF : ARRAY[ 1..MaxColors ] OF BOOLEAN;
    ColorDir, ColorOverflow : BYTE;
    TotalBytes : LONGINT;

{$L FSTCRT}
procedure FstCrt(Y,X,Attr : integer;St : Str80); external;

PROCEDURE MarkColor( VideoAttr : BYTE );
VAR I : BYTE;
BEGIN
  FOR I := 1 TO MaxColors DO IF ( VideoAttr = CA[ I, 1 ] + 16 * CA[ I, 2 ] )
    THEN ColorTF[ I ] := TRUE; { mark color as "already selected" }
END;

PROCEDURE AddColor( E : Str3; VideoAttr : BYTE );
BEGIN
  INC( NumColor );
  aEC[ Numcolor ].E := E;
  aEC[ Numcolor ].C := VideoAttr;
  MarkColor( VideoAttr );
END;

FUNCTION LastPos( Ch : CHAR; S : Str255 ) : BYTE;
VAR I : BYTE;
BEGIN
  FOR I := LENGTH( S ) DOWNTO 1 DO IF ( S[ I ] = Ch ) THEN BEGIN
    LastPos := I;
    EXIT;
  END;
  LastPos := 0;
END;

FUNCTION UpStr( AA : PathStr ) : PathStr;
VAR I : BYTE;
BEGIN
  FOR I := 1 TO LENGTH( AA ) DO AA[ I ] := UpCase( AA[ I ] );
  UpStr := AA;
END;

FUNCTION LoCase(C: CHAR): CHAR;
BEGIN
  IF ( ORD( C ) > 64 ) AND ( ORD( C ) < 91 )
    THEN LoCase := CHR( ORD( C ) + 32 )
    ELSE LoCase := C;
END;

FUNCTION Trim(AA:Str255):Str255;
BEGIN
  WHILE (COPY(AA,1,1)=' ') DO AA := COPY(AA,2,255);
  WHILE (COPY(AA,LENGTH(AA),1)=' ') DO AA := COPY(AA,1,LENGTH(AA)-1);
  Trim := AA;
END;

FUNCTION Pad(AAA:Str255;PS,PSD:BYTE):Str80;
(* AAA = string to pad
   PS = length of finished RETURN string
   PSD = (1 = pad on right; 2 = pad on left)  *)
  FUNCTION Spcs(SP:BYTE):Str80;
  VAR SPI : INTEGER;
      SPS : Str80;
  BEGIN
    SPS := '';
    FOR SPI := 1 TO SP DO SPS := SPS + ' ';
    Spcs := SPS;
  END;

BEGIN
   AAA := Trim(AAA);
   CASE PSD OF
   1 : AAA := COPY(AAA + Spcs(PS),1,PS);
   2 : AAA := COPY(Spcs(PS),1,PS-LENGTH(AAA)) + AAA;
   END; {CASE PSD}
   Pad := AAA;
END;

FUNCTION Replicate(AA:Str255;RJ:BYTE):Str255;
VAR RR : Str255;
    RI : BYTE;
BEGIN
  RR := '';
  FOR RI := 1 TO RJ DO RR := RR + COPY(AA,1,1);
  Replicate := RR;
END;

FUNCTION FullName(Dir : DirStr; zFile : Str12) : PathStr;
BEGIN
IF Dir[LENGTH(Dir)] = '\' THEN FullName := Dir + zFile
                          ELSE FullName := Dir + '\' + zFile;
END;

PROCEDURE Help;
VAR NC,NI : BYTE;
    S8 : Str8;
BEGIN
  WriteLn( 'CDIR ', Version, #32, Extra );
  WriteLn( 'CDIR displays a wide directory (DIR /W) using different colors' );
  WriteLn( '     based on file extension.' );
  WriteLn( 'Syntax: CDIR [pathspec] [/H] [/E]' );
  WriteLn;
  WriteLn( '    pathspec may include both a directory and/or file specification.' );
  WriteLn( '    If no drive & directory is specified, the current directory is assumed.' );
  WriteLn( '    If no file specification is included, "*.*" is assumed.' );
  WriteLn;
  WriteLn( '    /H    Show hidden files too.' );
  WriteLn( '    /E    List only the unique file extensions found (no other display).' );
  WriteLn;
  WriteLn( 'Optionally, you can create a file called CDIR.CFG to force certain extensions' );
  WriteLn( '  to be displayed in user-specified colors.  Each extension should appear on a' );
  WriteLn( '  separate line followed by a space and the video attribute from 0 to 255.' );
  WriteLn( 'Calculate video attributes using FOREGROUND-COLOR + (16 * BACKGROUND-COLOR).' );
  WriteLn( '  Colors: 0=black, 1=blue, 2=green, 3=cyan, 4=red, 5=magenta, 6=brown, 7=white.' );
  WriteLn( '  Add 8 to attribute for bright foreground color.  Add 128 for blinking.' );
  WriteLn( 'Sample line below displays EXE files in Bright White on Black:' );
  WriteLn( '  EXE 15' );
  WriteLn( 'Non-numeric characters following the video attribute are treated as a comment.' );
  WriteLn( 'CDIR.CFG is looked for in the same directory where CDIR.EXE is located.' );
  WriteLn( '  An alternate location for CDIR.CFG can be specified in env.var. CDIR.' );
  HALT;
END;

FUNCTION FM(M : Str12):Str12;   {Translate filespec w/ "*" into string w/ "?"}
VAR MM : Str12;
    MI : BYTE;
    MP : BOOLEAN;
BEGIN
  IF (POS('.',M) = 0) THEN M := M + '.';
  MM := '';
  MP := FALSE;
  FOR MI := 1 TO LENGTH(M) DO CASE M[MI] OF
    '*' : IF MP THEN MM := MM + REPLICATE('?',12-LENGTH(MM))
                ELSE MM := MM + REPLICATE('?',8-LENGTH(MM));
    '.' : BEGIN
          MM := PAD(MM,8,1) + '.';
          MP := TRUE;
          END;
    ELSE MM := MM + UpCase(M[MI]);
    END; {CASE MI}
  FM := PAD(MM,12,1);
END;

FUNCTION Match(S1,S2 : Str12) :BOOLEAN;
VAR M : BOOLEAN;
    MM : BYTE;
BEGIN
  M := TRUE;
  FOR MM := 1 TO 12 DO IF ((S1[MM] <> S2[MM]) AND (S2[MM] <> '?'))
      THEN M := FALSE;
  Match := M;
END;

PROCEDURE BoxClear(YT,XT,YB,XB:BYTE;QC:INTEGER;BCTF:BOOLEAN);
(* Coordinate pairs (YT,XT) & (YB,XB) define the box;
   QC = color to use
   BCTF = (TRUE - clear box & area inside box; FALSE - clear only the box) *)
VAR BI,BI2:BYTE;
BEGIN
  FOR BI := YT TO YB DO BEGIN
      IF ( ( (BI=YT) OR (BI=YB) ) OR BCTF) THEN
          FOR BI2 := XT TO XB DO FstCrt(BI,BI2,QC,' ')
          ELSE
          BEGIN
            FstCrt(BI,XT,QC,' ');
            FstCrt(BI,XB,QC,' ');
          END;
    END;
END;

FUNCTION Sign(SI : INTEGER) : ShortInt;
BEGIN
  IF (SI = 0) THEN Sign := 0 ELSE IF (SI > 0) THEN Sign := 1 ELSE Sign := -1;
END;

PROCEDURE Dsort (INK : byte);
 {Sort Arrays aFN[],aFE[],aFS[],aFT[],aFD[],aFA[] by element defined by INK}
 {INK = 1: filename,ext,dir; 2: ext,filename; 3: date & time (ascend),F,E;
        4: date & time (descend),F,E;  5: size;  6: dir #;
        7: attr,filename,ext  8: (directory attr first),filename,ext}

Var
  NS1,NS2,NS3,NS4,NS5 : INTEGER;
  SWF : Str8;
  SWE : Str3;
  SWS,SWT : LongInt;
  SWD,SWA,SWZ : Byte;
  NSB,NsbF,NsbE,NsbS,NsbT,NsbT2,NsbD,NsbA,NsbZ : BOOLEAN;

label spot0,spot1,spot2,spot3,spot4,spot5;

Begin    {Sort}
  if INK=8 then FOR NS1 := 1 TO INN DO
    IF aFA[NS1] = 16 THEN aFZ[NS1] := 0 ELSE
    {IF (aFA[NS1] AND 2 = 2) OR (aFA[NS1] AND 4 = 4) THEN aFZ[NS1] := 1 ELSE}
    aFZ[NS1] := 2;

  if INK=0 then INK := 1;
  if INN = 2 then
    Begin
      NS1 := 1;
      NS2 := 0;
      NS3 := 0;
      NS4 := 0;
      NS5 := 1;
      goto spot3;
    end;
  NS1 := INN;
 spot0:;
  NS1 := Trunc(NS1/2);
  if NS1 = 0 then goto spot5;
  NS2 := INN - NS1;
  NS3 := 1;
 spot1:;
  NS4 := NS3;
 spot2:;
  NS5 := NS4 + NS1;
 spot3:;

  NSB := FALSE;
  NsbF := FALSE;
  NsbE := FALSE;
  NsbS := FALSE;
  NsbT := FALSE;
  NsbT2 := FALSE;
  NsbD := FALSE;
  NsbA := FALSE;
  NsbZ := FALSE;
  IF aFN[NS4] > aFN[NS5] THEN NsbF := TRUE;
  IF aFE[NS4] > aFE[NS5] THEN NsbE := TRUE;
  IF aFS[NS4] > aFS[NS5] THEN NsbS := TRUE;
  IF aFT[NS4] > aFT[NS5] THEN NsbT := TRUE;
  IF aFT[NS5] > aFT[NS4] THEN NsbT2 := TRUE;
  IF aFD[NS4] > aFD[NS5] THEN NsbD := TRUE;
  IF aFA[NS4] > aFA[NS5] THEN NsbA := TRUE;
  IF aFZ[NS4] > aFZ[NS5] THEN NsbZ := TRUE;
  CASE INK OF
    1 : IF NsbF THEN NSB := TRUE ELSE IF (aFN[NS4] = aFN[NS5]) THEN
        IF NsbE THEN NSB := TRUE ELSE IF (aFE[NS4] = aFE[NS5]) THEN
        IF NsbD THEN NSB := TRUE;
    2 : IF NsbE THEN NSB := TRUE ELSE IF (aFE[NS4] = aFE[NS5]) THEN
        IF NsbF THEN NSB := TRUE;
    3 : IF NsbT THEN NSB := TRUE ELSE IF (aFT[NS4] = aFT[NS5]) THEN
        IF NsbF THEN NSB := TRUE ELSE IF (aFN[NS4] = aFN[NS5]) THEN
        IF NsbE THEN NSB := TRUE;
    4 : IF NsbT2 THEN NSB := TRUE ELSE IF (aFT[NS4] = aFT[NS5]) THEN
        IF NsbF THEN NSB := TRUE ELSE IF (aFN[NS4] = aFN[NS5]) THEN
        IF NsbE THEN NSB := TRUE;
    5 : IF NsbS THEN NSB := TRUE;
    6 : IF NsbD THEN NSB := TRUE;
    7 : IF NsbA THEN NSB := TRUE ELSE IF (aFA[NS4] = aFA[NS5]) THEN
        IF NsbF THEN NSB := TRUE ELSE IF (aFN[NS4] = aFN[NS5]) THEN
        IF NsbE THEN NSB := TRUE;
    8 : IF NsbZ THEN NSB := TRUE ELSE IF (aFZ[NS4] = aFZ[NS5]) THEN
        IF NsbF THEN NSB := TRUE ELSE IF (aFN[NS4] = aFN[NS5]) THEN
        IF NsbE THEN NSB := TRUE;
  END; {CASE}

  if (NOT NSB) then goto spot4;
if (NS4>0) and (NS4<=INN) and (NS5>0) and (NS5<=INN) then
 Begin
  SWF := aFN[NS4] ; aFN[NS4] := aFN[NS5]; aFN[NS5] := SWF;
  SWE := aFE[NS4] ; aFE[NS4] := aFE[NS5]; aFE[NS5] := SWE;
  SWS := aFS[NS4] ; aFS[NS4] := aFS[NS5]; aFS[NS5] := SWS;
  SWT := aFT[NS4] ; aFT[NS4] := aFT[NS5]; aFT[NS5] := SWT;
  SWD := aFD[NS4] ; aFD[NS4] := aFD[NS5]; aFD[NS5] := SWD;
  SWA := aFA[NS4] ; aFA[NS4] := aFA[NS5]; aFA[NS5] := SWA;
  SWZ := aFZ[NS4] ; aFZ[NS4] := aFZ[NS5]; aFZ[NS5] := SWZ;
 End;
  NS4 := NS4 - NS1;
  if NS4 >= 1 then goto spot2;
 spot4:;
  NS3 := NS3 + 1;
  if NS3 > NS2 then goto spot0;
  goto spot1;
 spot5:;

END;  {Sort}

PROCEDURE ReadTheDir(Dmask : Str12);
VAR
  DirInfo  : SearchRec;
  FileName : Str12;
  IB     : BYTE;
BEGIN
  INN := 0;  { # of files }

  FindFirst('*.*',AnyFile,DirInfo);
  WHILE (DosError = 0) DO BEGIN
    FileName := DirInfo.Name;
    { Exclude . and .. directories AND volume labels }
    IF ((FileName[1] <> '.') AND (DirInfo.Attr <> 8)) THEN BEGIN
      {Include directories regardless of name AND only files matching spec}
      IF ( ((DirInfo.Attr AND 16) = 16) OR Match(FM(Filename),Dmask) )
      THEN IF (((DirInfo.Attr AND 2 <> 2) AND (DirInfo.Attr AND 4 <> 4)) OR
              ShowHid) THEN BEGIN
        INC(INN);
        IB := POS('.',FileName);
        IF (IB>0) THEN BEGIN
          aFE[INN] := COPY(FileName,IB+1,3);
          aFN[INN] := COPY(FileName,1,IB-1);
            END ELSE BEGIN
          aFN[INN] := FileName;
          aFE[INN] := #0;
          END;
        aFS[INN] := DirInfo.Size;
        aFT[INN] := DirInfo.Time;
        aFA[INN] := DirInfo.Attr;
        aFD[INN] := 0;
        aFZ[INN] := 0;
        TotalBytes := TotalBytes + aFS[ INN];
        END;
      END;
    FindNext(DirInfo);
    END;
END;

FUNCTION PrintUsing(N:longint): Str20;
(* PrintUsing functon to insert commas into a LONGINT value for
   purposing of display filesizes more clearly: 150,456 rather than 150456. *)
VAR S1,S2 : Str20;
BEGIN
  IF (N=0) THEN PrintUsing := '0' ELSE BEGIN
    STR(N:TRUNC( LN(N)/LN(10) )+1,S1);
    S2 := '';
    WHILE (LENGTH(S1)>3) DO BEGIN
      S2 := COPY(S1,LENGTH(S1)-2,3) + S2;
      S1 := COPY(S1,1,LENGTH(S1)-3);
      S2 := ',' + S2;
      END;
    PrintUsing := S1 + S2;
    END;
END;

PROCEDURE DisplayDir( DispType : BYTE; DirTitle : Str80 );
CONST MaxRows = 23;
      OverFlow = 'Non-unique file exts. are in this color.';
VAR I,J,K,L,M,MM,MR,N,IND,INF,III : INTEGER;
    F                 : Str12;
    Free              : LongInt;
    Ch                : CHAR;
    Ext               : Str3;

  PROCEDURE AssignColor;
  VAR ACM : INTEGER;
      S3 : Str3;
      y, m, d, dow, y2, m2, d2 : Word;
      dt : DateTime; {For Pack/UnpackTime:
                      DateTime = record
                                 Year,Month,Day,Hour,
                                 Min,Sec: Word;
                                 end;  }
      NN  : BYTE;
      CTF : BOOLEAN;
  BEGIN {AssignColor}
    Dsort(2);    {SORT: Extension, filename}
    FOR ACM := 1 TO INN DO
      IF ( ( aFA[ ACM ] AND 16 ) = 16 ) THEN BEGIN
        aFD[ ACM ] := ColorDir;   {Color for Directory}
      END ELSE BEGIN
        CTF := FALSE;
        FOR NN := 1 TO NumColor DO
          IF ( aFE[ ACM ] = aEC[ NN ].E ) THEN BEGIN
            aFD[ACM] := aEC[ NN ].C;
            CTF := TRUE;
            BREAK;
          END; { FOR - IF }
        IF NOT CTF THEN FOR NN := 1 TO MaxColors DO
          IF ( NOT ColorTF[ NN ] ) THEN BEGIN
            AddColor( aFE[ ACM ], CA[ NN, 1 ] + 16 * CA[ NN, 2 ] );
            aFD[ACM] := aEC[ NumColor ].C;
            CTF := TRUE;
            BREAK;
          END;
        IF NOT CTF THEN BEGIN
          aFD[ACM] := ColorOverflow;
          OverflowTF := TRUE;
        END;
      END;
  END;  {AssignColor}

BEGIN   { DisplayDir }
  CASE DispType OF
    1: BEGIN
         AssignColor;

         M := TRUNC(INN/6) + Sign(INN MOD 6);          { Total rows }
         MM := TRUNC(M/MaxRows) + Sign(M MOD MaxRows); { Total screens }

         Dsort(8);  {SORT: Attribute, filename, extension}

         IND := 0;
         INF := 0;

         IF (MM = 0) THEN BEGIN
           WriteLn(DirTitle);
           Free := DiskFree(ORD(DirTitle[1])-64);
           WriteLn(PrintUsing(IND),' Directory(s)    ',PrintUsing(INF),
                   ' File(s)    ',PrintUsing(Free),' byte free.');
           END ELSE
         FOR I := 1 TO MM DO BEGIN
           BoxClear(1,1,25,80,7,TRUE);
           FstCrt(1,2,7,DirTitle);

           IF (I < MM) THEN MR := MaxRows
             ELSE MR := TRUNC((INN - (I-1) * 6 * MaxRows)/6) +
                        Sign((INN - (I-1) * 6 * MaxRows) MOD 6);

           FOR J := 1 TO 6 DO FOR K := 1 TO MR DO BEGIN
             L := (I-1) * MaxRows * 6 + (J-1) * MR + K;   {Element #}
             N := (J-1) * 13 + 2;  {X-coordinate}
             IF (L <= INN) THEN BEGIN
               IF ((aFA[L] AND 16) = 16) THEN INC(IND) ELSE INC(INF);
                 IF (LENGTH(aFE[L]) > 0)
                   THEN F := Pad(aFN[L],8,1) + '.' + Pad(aFE[L],3,1)
                   ELSE F := Pad(aFN[L],12,1);
               IF ((aFA[L] AND 2 = 2) OR (aFA[L] AND 4 = 4)) THEN
                 FOR III := 1 TO LENGTH(F) DO F[III] := LoCase(F[III]);
               FstCrt(K+1,N,aFD[L],F);
               END;
             IF LinesBT THEN BEGIN
               IF (J = 1) THEN FstCrt(K+1,1,LineColor,LinesCh);
               FstCrt(K+1,N+12,LineColor,LinesCh);
               END;
             END;

           IF (I < MM) THEN BEGIN
               FstCrt(MR+2,2,7,'-- More.  Press a key. --');
               GOTOXY(27,MR+2);
               Ch := READKEY;
               IF (Ch = #27) THEN BEGIN
                 FstCrt(MR+2,2,7,Replicate(#32,25));
                 GOTOXY(79,24);
                 EXIT;
               END;
               IF KeyPressed THEN Ch := READKEY; {toss 2nd key if function key}
             END ELSE BEGIN
               Free := DiskFree( ORD( DirTitle[ 1 ] ) - 64 );
               DirTitle := PrintUsing(IND) + ' Directory(s)    ' +
                           PrintUsing(INF) + ' File(s)    Bytes: ' +
                           PrintUsing(TotalBytes) + ' used; ' +
                           PrintUsing(Free) + ' free.';
                           (* PrintUsing(Free) + ' byte free.   '; *)
               FstCrt(MR+2,2,7,DirTitle);
               IF OverFlowTF THEN FstCrt( 1, 80 - LENGTH( OverFlow ),
                                  ColorOverflow, OverFlow );
               GOTOXY(1,MR+2);
             END;
           END;
       END;
    2: BEGIN
         WriteLn('Extensions: ' + DirTitle);
         Dsort(2);
         Ext := '.';  {Illegal extension}
         FOR M := 1 TO INN DO
           IF ((aFA[M] AND 16) <> 16) THEN BEGIN {NOT a Directory}
             IF (aFE[M] <> Ext) THEN BEGIN
               Ext := aFE[M];
               IF ( Ext = #0 ) THEN Write( 'No-Extension   ' )
                               ELSE Write( Pad( Ext, 5, 1 ) );
             END;
           END;
       END;
  END; {CASE DispType}
END;   { DisplayDir }

PROCEDURE ReadAndSort( FullSpec, P2 : PathStr );
VAR StartDir,CurDir,DirSpec : DirStr;
    FileSpec : Str12;
    OtherDir : BOOLEAN;
    II,IR : BYTE;
    Temp80 : Str80;
BEGIN     { ReadAndSort }
  IF (FullSpec = '/?') THEN Help;

  ShowHid := FALSE;

  IF (FullSpec[1] = '/') THEN BEGIN
    Temp80 := FullSpec;
    FullSpec := P2;
    P2 := Temp80;
    END;
  IF (P2 <> '') THEN FOR II := 1 TO LENGTH(P2) DO P2[II] := UpCase(P2[II]);
  IF P2 = '/H' THEN ShowHid := TRUE;

  GetDir( 0, StartDir );

  {$I-}
  ChDir( FullSpec );
  {$I+}
  IF ( IOresult = 0 ) THEN BEGIN   {Only directory name was passed}
    DirSpec := FullSpec;
    GetDir(0,DirSpec);
    FileSpec := '*.*';
    OtherDir := TRUE;
    END ELSE BEGIN
    II := 0;
    FOR IR := LENGTH(FullSpec) DOWNTO 1 DO IF (II = 0) THEN
      IF (FullSpec[IR] = '\') THEN II := IR;
      IF (II = 0) THEN BEGIN   {Only FileSpec was passed}
      GetDir(0,DirSpec);
      FileSpec := FullSpec;
      END ELSE BEGIN
      DirSpec := COPY(FullSpec,1,II-1);
      IF (POS('\',DirSpec) = 0) THEN DirSpec := DirSpec + '\';
      {$I-}
      ChDir(DirSpec);
      {$I+}
      IF (IOresult = 0) THEN BEGIN   {Directory name is valid}
        GetDir(0,DirSpec);
        OtherDir := TRUE;
        END ELSE BEGIN
        WriteLn('Invalid directory specified.');
        HALT(1);
        END;
      FileSpec := COPY( FullSpec, II + 1, 12 );
      END;
    END;

  FOR II := 1 TO LENGTH(FileSpec) DO FileSpec[II] := UpCase(FileSpec[II]);
  ReadTheDir(FM(FileSpec));

  IF (DirSpec[LENGTH(DirSpec)] = '\') THEN FullSpec := DirSpec + FileSpec
    ELSE FullSpec := DirSpec + '\' + FileSpec;

  IF ( P2 = '/E' ) THEN DisplayDir( 2, DirSpec )
                   ELSE DisplayDir( 1, FullSpec );

  IF OtherDir THEN ChDir(StartDir);
END;      { ReadAndSort }

PROCEDURE SetUpColors;
VAR I, J : BYTE;
    P : PathStr;
    FR : TEXT;
    A, B, C : STRING;
    IE : INTEGER;
    EnvVar : Str12;
BEGIN
  NumColor := 0;
  FOR I := 1 TO MaxColors DO ColorTF[ I ] := FALSE;
  ColorDir := 0;
  ColorOverflow := 0;
  OverflowTF := FALSE;

  P := FExpand( ParamStr( 0 ) );
  I := LastPos( '.', P );
  P := COPY( P, 1, I ) + 'CFG'; { CDIR.CFG }

  EnvVar := GetEnv( 'CDIR' );
  IF NOT ( EnvVar = '' ) THEN BEGIN
    IF NOT ( FSearch( EnvVar, '' ) = '' ) THEN P := EnvVar ELSE
      IF NOT ( FSearch( FullName( EnvVar, 'CDIR.CFG' ), '' ) = '' )
      THEN P := FullName( EnvVar, 'CDIR.CFG' );
  END;

  IF NOT ( FSearch( P, '' ) = '' ) THEN BEGIN
    ASSIGN( FR, P );
    RESET( FR );
    REPEAT
      ReadLn( FR, A );
      A := UpStr( A );
      J := POS( #32, A );
      IF ( J > 0 ) THEN BEGIN
        B := Trim( COPY( A, J + 1, 255 ) );
        A := Trim( COPY( A, 1, J - 1 ) );
        C := '';
        FOR I := 1 TO LENGTH( B ) DO
          IF B[ I ] IN [ '0'..'9' ]
          THEN C := C + B[ I ] ELSE BREAK;
        VAL( C, J, IE );
        IF ( IE = 0 ) AND ( J <> 0 ) THEN BEGIN
          IF ( A = '<DIR>' ) THEN BEGIN
            ColorDir := J;
          END ELSE IF ( A = 'OVERFLOW' ) THEN BEGIN
            ColorOverflow := J;
          END ELSE AddColor( A, J );
        END;
      END;
    UNTIL EOF( FR );
    CLOSE( FR );
  END;
  IF ( ColorDir = 0 ) THEN ColorDir := DirColor; { directory color }
  IF ( ColorOverflow = 0 ) THEN ColorOverflow := OverflowColor;   { default "Overflow" color }
  MarkColor( ColorDir );
  MarkColor( ColorOverflow );
END;

BEGIN
  LinesBT := TRUE;
  LinesCh := #179;
  TotalBytes := 0;
  SetUpColors;
  ReadAndSort( PARAMSTR( 1 ), PARAMSTR( 2 ) );
END.
