        TITLE   FstCrt
        PAGE    55,132

;*****************************************************************************
;*  FstCrt is a machine language program written to interface to Borland     *
;*  Pascal 7.0 (originally written for TURBO Pascal Version 4.0, and         *
;*  unchanged other than this comment block).                                *
;*                                                                           *
;*  This ASM routine assembles using Microsoft MASM Version 3.0, Microsoft   *
;*  MASM 5.1, or Turbo Assembler 1.01.  It is likely to be assemblable       *
;*  with most any MS-DOS-compliant assembler.                                *
;*                                                                           *
;*  This routine is a replacement for Write.  It is as fast as possible to   *
;*  write on a CGA adapter without causing snow on the screen.  The routine  *
;*  incorporates cursor addressing, display attributes for both color and    *
;*  monochrome with the selection of adapter type occuring automatically,    *
;*  and printing of a string in either constant or variable format.          *
;*                                                                           *
;*  This routine was adapted from a program obtained from a bulletin board.  *
;*  It worked but was difficult to understand.  The routine was originally   *
;*  called Qwrite. Unfortunately, the original notes from the Qwrite source  *
;*  code have been lost, and thus we cannot acknowledge its author here.     *
;*                                                                           *
;*  The following .PAS file is a test program which shows how to interface   *
;*  the machine language routine.                                            *
;*                                                                           *
;*    Program Test;                                                          *
;*                                                                           *
;*    type                                                                   *
;*      Str80 = string[80];                                                  *
;*                                                                           *
;*    var                                                                    *
;*      Ch : Str80;                                                          *
;*                                                                           *
;*    {$L FSTCRT}                                                            *
;*    procedure FstCrt(Y,X,Attr : integer;St : Str80); external;             *
;*                                                                           *
;*    { Attr is a value from 0 to 255 can be calculated by the formula:      *
;*      FOREGROUND-COLOR + (16 * BACKGROUND-COLOR),                          *
;*      where the colors are values from 0 to 7:                             *
;*            0=black                                                        *
;*            1=blue                                                         *
;*            2=green                                                        *
;*            3=cyan                                                         *
;*            4=red                                                          *
;*            5=magenta                                                      *
;*            6=brown                                                        *
;*            7=white                                                        *
;*      Add 8 to attribute for bright foreground color.                      *
;*      Add 128 for blinking. }                                              *
;*                                                                           *
;*                                                                           *
;*    procedure Main;                                                        *
;*    begin                                                                  *
;*      Ch := 'You can use any string 80 characters long.';                  *
;*      FstCrt(1,1,12,'This is the new printing routine procedure.');        *
;*      FstCrt(2,1,12,'This is the new printing routine procedure.');        *
;*      FstCrt(3,1,12,'This is the new printing routine procedure.');        *
;*      FstCrt(4,1,12,Ch);                                                   *
;*    end;                                                                   *
;*                                                                           *
;*    begin                                                                  *
;*      Main;                                                                *
;*    end.                                                                   *
;*                                                                           *
;*****************************************************************************


CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE

        PUBLIC  FstCrt

iRow            EQU     BYTE PTR [BP+12]
iCol            EQU     WORD PTR [BP+10]
wAttr           EQU     WORD PTR [BP+8]
stWrite         EQU     DWORD PTR [BP+4]


FstCrt      PROC        NEAR
            push    bp
            mov     bp,sp
            push    ds
            cld                           ; Set string operations to increment
            lds     si, stWrite           ; Load St pointer into DS:SI
            lodsw                         ; Load ax with first two bytes
            xor     cx,cx                 ; Zero cx
            mov     es,cx                 ; Set es to point to base page of memory
            add     cl,al                 ; Put St length in cl and set flags
            jnz     qw1                   ; If nothing in St exit back to caller
            jmp     done
qw1:        mov     dh, iRow              ; Get row value
            dec     dh                    ; convert row to 0 - 24 form
            mov     di, iCol              ; Get column value
            dec     di                    ; Convert column to 0 - 79 form
            shl     di,1                  ; Double columns to account for attribute
            mov     bx, wAttr             ; Get attribute value
            mov     dl,ch                 ; Set dl=0
;
;  The mysterious shifts that follow are used to convert row and column
;  addresses into an offset into the memory on the display adapter.  The
;  formula is (row * 80) + column.  The row is shifted from the high byte
;  one position right to obtain row times 128.  The result is then added
;  DI.  The row is then shifted twice more to get the row times 32.  This
;  this value is then added to DI.  DI now contains the row value times
;  160 + the column which was corrected to 0 - 79 form and added to DI
;  previously.
;
            shr     dx,1                  ; Row times 128
            add     di,dx                 ; DI now has column + row times 128
            shr     dx,1                  ; Row times 64
            shr     dx,1                  ; Row times 32
            add     di,dx                 ; DI now has Row times 160 + column
            mov     al,ah                 ; Put first byte of string in al
            cmp     es:byte ptr [0449h], 07h ; Check to see if equipment says MDA
            jne     color                 ; If <> 07 then CGA or EGA

mono:       mov     dx,0b000h             ; Start address of MDA memory
            mov     es,dx                 ; Set es to MDA memory
ega:        test    bh,bh                 ; Test for an attribute value < 0
            js      mono1                 ; If 0, the do write w/o attribute

;
;  Monochrome routine which writes the string with attribute byte
;

            mov     ah,bl                 ; Put attribute in ah
mono2:      inc     cx                    ; Inc cx by 1 to fix odd length
            shr     cx,1                  ; Divide cx by two, CF = 0 if odd
            jmp     short mon2b           ; Go do mono display

mon2a:      lodsw                         ; Load 2 chars
            mov     bh,ah                 ; put 2nd char in bh
            mov     ah,bl                 ; put attribute in ah
            stosw                         ; Put char and attr in memory
            mov     al,bh                 ; Get second char
mon2b:      stosw                         ; Put char and attr in memroy
            loop    mon2a                 ; Loop until cx=0
            jnc     done                  ; Exit if St length is odd
            lodsb                         ; Load last char
            stosw                         ; Put char and attr in memory
            jmp     short done

;
;  Monochrome routine which writes the string without attribute byte
;

mono1:      inc      cx                   ; Inc cx by 1 to fix odd length
            mov      dx,cx                ; Save ds in cx
            shr      cx,1                 ; Divide by 2
            jmp      short mon1b          ; Go do mono display

mon1a:      lodsw                         ; Load 2 char
            stosb                         ; Store one char
            inc      di                   ; Bypass attribute
            mov      al,ah                ; Get 2nd char
mon1b:      stosb                         ; Stor one char
            inc      di                   ; Bypass attribute
            loop     mon1a                ; Loop until cx=0
            shr      dx,1                 ; Divide St len by 2, CF=0 if odd
            jnc      done                 ; Exit if odd length
            lodsb                         ; Load last char
            stosb                         ; Store last char
            jmp      short done

;
; Color routine start
;

color:                                    ; Add routine here later to test EGA
            mov      dx,0b800h            ; Get CGA segment address
            mov      es,dx
;           jne      ega                  ; If EGA, do a monochrome fill
            mov      dx,03dah             ; Get address of CGA port
            test     bh,bh                ; Check if attr < 0
            js       col1b                ; If < 0 go do char fill only
            mov      ah,bl                ; Put attribute byte in ah
            jmp      short col2b          ; Go do attribute and char fill

;
;  Color routine which writes the string with attribute byte
;
col2a:      lodsb                         ; Load first char
col2b:      mov      bh,al                ; Save char for alter
            cli                           ; Disable interrupts for write
e4in2:      in       al,dx                ; Get CGA status byte
            test     al,08h               ; Test bit 3
            jz       col2c                ; If bit 3 = 0, continue to loop
            mov      al,bh                ; Get char back
            cmp      cl,90h               ; Check if less than 145 columns
            js       mono2                ; do monochrome update instead
            jmp      short col2d          ; else store and continue
col2c:      rcr      al,1                 ; If bit 0 set try again
            jc       e4in2
e5in2:      in       al,dx                ; Get CGA status byte
            rcr      al,1                 ; If bit 0 clear try again
            jnc      e5in2
            mov      al,bh                ; Get char back
col2d:      stosw                         ; Store in CGA display memory
            sti                           ; Enable interrupts
            loop     col2a                ; Loop till cx=0
            jmp      short done

;
;  Color routine which writes the string without attribute byte
;

col1a:      lodsb                         ; Get a char
            inc      di                   ; Inc past attribute
col1b:      mov      bh,al                ; Save char for later
            cli                           ; Disable interrupts
e4in1:      in       al,dx                ; Get CGA status byte
            test     al,08h               ; If bit 3 clear
            jz       col1c                ; Continue
            mov      al,bh                ; Get char back
            cmp      cl,80H               ; If less than 129 columns
            js       mono1                ; Do mono instead
            jmp      short col1d          ; Else store direct
col1c:      rcr      al,1                 ; If bit 0 set
            jc       e4in1                ; try again
e5in1:      in       al,dx                ; Get CGA status byte
            rcr      al,1                 ; If bit 0 is clear
            jnc      e5in1                ; Try again
            mov      al,bh                ; Put char in al
col1d:      stosb                         ; Put in CGA memory
            sti                           ; Enable interrupts
            loop     col1a
done:       pop      ds                   ; Clean stack up
            pop      bp
            ret      10                   ; Return to caller

FstCrt      ENDP

CODE        ENDS

            END

;*****************************************************************************
;* eof FSTCRT.ASM                                                            *
;*****************************************************************************
